## API Report File for "@microsoft/fast-foundation"

> Do not edit this file. It is a report generated by [API Extractor](https://api-extractor.com/).

```ts

import { AttributeConfiguration } from '@microsoft/fast-element';
import { Behavior } from '@microsoft/fast-element';
import { ComposableStyles } from '@microsoft/fast-element';
import { Constructable } from '@microsoft/fast-element';
import { CSSDirective } from '@microsoft/fast-element';
import { Direction } from '@microsoft/fast-web-utilities';
import { ElementStyles } from '@microsoft/fast-element';
import { ElementViewTemplate } from '@microsoft/fast-element';
import { FASTElement } from '@microsoft/fast-element';
import { Orientation } from '@microsoft/fast-web-utilities';
import { PartialFASTElementDefinition } from '@microsoft/fast-element';
import { SyntheticViewTemplate } from '@microsoft/fast-element';
import { ViewTemplate } from '@microsoft/fast-element';

// @public
export class Accordion extends FoundationElement {
    // @internal (undocumented)
    accordionItems: HTMLElement[];
    // @internal (undocumented)
    accordionItemsChanged(oldValue: any, newValue: any): void;
    expandmode: AccordionExpandMode;
    }

// @public
export enum AccordionExpandMode {
    multi = "multi",
    single = "single"
}

// Warning: (ae-different-release-tags) This symbol has another declaration with a different release tag
// Warning: (ae-internal-mixed-release-tag) Mixed release tags are not allowed for "AccordionItem" because one of its declarations is marked as @internal
//
// @public
export class AccordionItem extends FoundationElement {
    // @internal (undocumented)
    clickHandler: (e: MouseEvent) => void;
    // @internal (undocumented)
    expandbutton: HTMLElement;
    expanded: boolean;
    headinglevel: 1 | 2 | 3 | 4 | 5 | 6;
    id: string;
}

// @internal
export interface AccordionItem extends StartEnd {
}

// @public
export type AccordionItemOptions = FoundationElementDefinition & {
    expandedIcon?: string | SyntheticViewTemplate;
    collapsedIcon?: string | SyntheticViewTemplate;
};

// @public
export const accordionItemTemplate: (context: ElementDefinitionContext, definition: AccordionItemOptions) => ViewTemplate<AccordionItem>;

// @public
export const accordionTemplate: (context: ElementDefinitionContext, definition: FoundationElementDefinition) => ViewTemplate<Accordion>;

// @public
export const all: (key: any, searchAncestors?: boolean | undefined) => ReturnType<typeof DI.inject>;

// Warning: (ae-different-release-tags) This symbol has another declaration with a different release tag
// Warning: (ae-internal-mixed-release-tag) Mixed release tags are not allowed for "Anchor" because one of its declarations is marked as @internal
//
// @public
export class Anchor extends FoundationElement {
    control: HTMLAnchorElement;
    // @internal
    defaultSlottedContent: HTMLElement[];
    download: string;
    href: string;
    hreflang: string;
    ping: string;
    referrerpolicy: string;
    rel: string;
    target: "_self" | "_blank" | "_parent" | "_top";
    type: string;
}

// @internal
export interface Anchor extends StartEnd, DelegatesARIALink {
}

// @beta
export class AnchoredRegion extends FoundationElement {
    // @internal (undocumented)
    adoptedCallback(): void;
    anchor: string;
    anchorElement: HTMLElement | null;
    // (undocumented)
    autoUpdateMode: AutoUpdateMode;
    // @internal (undocumented)
    connectedCallback(): void;
    // @internal (undocumented)
    disconnectedCallback(): void;
    fixedPlacement: boolean;
    horizontalDefaultPosition: HorizontalPosition;
    horizontalInset: boolean;
    // Warning: (ae-forgotten-export) The symbol "AnchoredRegionHorizontalPositionLabel" needs to be exported by the entry point index.d.ts
    horizontalPosition: AnchoredRegionHorizontalPositionLabel;
    horizontalPositioningMode: AxisPositioningMode;
    horizontalScaling: AxisScalingMode;
    horizontalThreshold: number;
    // @internal
    initialLayoutComplete: boolean;
    update: () => void;
    updateAnchorOffset: (horizontalOffsetDelta: number, verticalOffsetDelta: number) => void;
    verticalDefaultPosition: VerticalPosition;
    verticalInset: boolean;
    // Warning: (ae-forgotten-export) The symbol "AnchoredRegionVerticalPositionLabel" needs to be exported by the entry point index.d.ts
    verticalPosition: AnchoredRegionVerticalPositionLabel;
    verticalPositioningMode: AxisPositioningMode;
    verticalScaling: AxisScalingMode;
    verticalThreshold: number;
    viewport: string;
    viewportElement: HTMLElement | null;
    }

// @beta
export const anchoredRegionTemplate: (context: ElementDefinitionContext, definition: FoundationElementDefinition) => ViewTemplate<AnchoredRegion>;

// @public
export const anchorTemplate: (context: ElementDefinitionContext, definition: FoundationElementDefinition) => ViewTemplate<Anchor>;

// @public
export function applyMixins(derivedCtor: any, ...baseCtors: any[]): void;

// @public
export class ARIAGlobalStatesAndProperties {
    ariaAtomic: "true" | "false";
    ariaBusy: "true" | "false";
    ariaControls: string;
    ariaCurrent: "page" | "step" | "location" | "date" | "time" | "true" | "false" | string;
    ariaDescribedby: string;
    ariaDetails: string;
    ariaDisabled: "true" | "false";
    ariaErrormessage: string;
    ariaFlowto: string;
    ariaHaspopup: "false" | "true" | "menu" | "listbox" | "tree" | "grid" | "dialog";
    ariaHidden: "false" | "true" | undefined;
    ariaInvalid: "false" | "true" | "grammar" | "spelling";
    ariaKeyshortcuts: string;
    ariaLabel: string;
    ariaLabelledby: string;
    ariaLive: "assertive" | "off" | "polite";
    ariaOwns: string;
    ariaRelevant: "additions" | "additions text" | "all" | "removals" | "text";
    ariaRoledescription: string;
}

// @beta
export type AutoUpdateMode = "anchor" | "auto";

// @public
export class Avatar extends FoundationElement {
    color: string;
    connectedCallback(): void;
    fill: string;
    link: string;
    // Warning: (ae-forgotten-export) The symbol "AvatarShape" needs to be exported by the entry point index.d.ts
    shape: AvatarShape;
}

// @public
export type AvatarOptions = FoundationElementDefinition & {
    media?: string | SyntheticViewTemplate;
};

// @public
export const avatarTemplate: (context: ElementDefinitionContext, definition: AvatarOptions) => ViewTemplate<Avatar>;

// @beta
export type AxisPositioningMode = "uncontrolled" | "locktodefault" | "dynamic";

// @beta
export type AxisScalingMode = "anchor" | "fill" | "content";

// @public
export class Badge extends FoundationElement {
    circular: boolean;
    color: string;
    fill: string;
    // (undocumented)
    generateBadgeStyle: () => string | undefined;
}

// @public
export const badgeTemplate: (context: ElementDefinitionContext, definition: FoundationElementDefinition) => ViewTemplate<Badge>;

// @public
export class BaseProgress extends FoundationElement {
    max: number;
    min: number;
    paused: any;
    value: number | null;
}

// @public
export class Breadcrumb extends FoundationElement {
    // @internal (undocumented)
    slottedBreadcrumbItems: HTMLElement[];
    // (undocumented)
    slottedBreadcrumbItemsChanged(): void;
}

// Warning: (ae-different-release-tags) This symbol has another declaration with a different release tag
// Warning: (ae-internal-mixed-release-tag) Mixed release tags are not allowed for "BreadcrumbItem" because one of its declarations is marked as @internal
//
// @public
export class BreadcrumbItem extends Anchor {
    // @internal (undocumented)
    separator: boolean;
}

// @internal
export interface BreadcrumbItem extends StartEnd, DelegatesARIALink {
}

// @public
export type BreadcrumbItemOptions = FoundationElementDefinition & {
    separator?: string | SyntheticViewTemplate;
};

// @public
export const breadcrumbItemTemplate: (context: ElementDefinitionContext, definition: BreadcrumbItemOptions) => ViewTemplate<BreadcrumbItem>;

// @public
export const breadcrumbTemplate: (context: ElementDefinitionContext, definition: FoundationElementDefinition) => ViewTemplate<Breadcrumb>;

// Warning: (ae-different-release-tags) This symbol has another declaration with a different release tag
// Warning: (ae-forgotten-export) The symbol "FormAssociatedButton" needs to be exported by the entry point index.d.ts
// Warning: (ae-internal-mixed-release-tag) Mixed release tags are not allowed for "Button" because one of its declarations is marked as @internal
//
// @public
export class Button extends FormAssociatedButton {
    autofocus: boolean;
    // @internal (undocumented)
    connectedCallback(): void;
    // (undocumented)
    control: HTMLButtonElement;
    defaultSlottedContent: HTMLElement[];
    formaction: string;
    formenctype: string;
    formId: string;
    formmethod: string;
    formnovalidate: boolean;
    formtarget: "_self" | "_blank" | "_parent" | "_top";
    type: "submit" | "reset" | "button";
    }

// @internal
export interface Button extends StartEnd, DelegatesARIAButton {
}

// @public
export const buttonTemplate: (context: ElementDefinitionContext, definition: FoundationElementDefinition) => ViewTemplate<Button>;

// @public
export class Card extends FoundationElement {
}

// @public
export const cardTemplate: (context: ElementDefinitionContext, definition: FoundationElementDefinition) => ViewTemplate<Card>;

// Warning: (ae-forgotten-export) The symbol "FormAssociatedCheckbox" needs to be exported by the entry point index.d.ts
//
// @public
export class Checkbox extends FormAssociatedCheckbox {
    constructor();
    checked: boolean;
    checkedAttribute: boolean;
    // @internal (undocumented)
    clickHandler: (e: MouseEvent) => void;
    // @internal (undocumented)
    connectedCallback(): void;
    defaultChecked: boolean;
    // @internal (undocumented)
    defaultSlottedNodes: Node[];
    // @internal (undocumented)
    formResetCallback: () => void;
    indeterminate: boolean;
    // @internal
    initialValue: string;
    // @internal (undocumented)
    keypressHandler: (e: KeyboardEvent) => void;
    readOnly: boolean;
    }

// @public
export type CheckboxOptions = FoundationElementDefinition & {
    checkedIndicator?: string | SyntheticViewTemplate;
    indeterminateIndicator?: string | SyntheticViewTemplate;
};

// @public
export const checkboxTemplate: (context: ElementDefinitionContext, definition: CheckboxOptions) => ViewTemplate<Checkbox>;

// @public
export interface ColumnDefinition {
    cellFocusTargetCallback?: (cell: DataGridCell) => HTMLElement;
    cellInternalFocusQueue?: boolean;
    cellTemplate?: ViewTemplate;
    columnDataKey: string;
    gridColumn?: string;
    headerCellFocusTargetCallback?: (cell: DataGridCell) => HTMLElement;
    headerCellInternalFocusQueue?: boolean;
    headerCellTemplate?: ViewTemplate;
    title?: string;
}

// Warning: (ae-different-release-tags) This symbol has another declaration with a different release tag
// Warning: (ae-forgotten-export) The symbol "FormAssociatedCombobox" needs to be exported by the entry point index.d.ts
// Warning: (ae-internal-mixed-release-tag) Mixed release tags are not allowed for "Combobox" because one of its declarations is marked as @internal
//
// @public
export class Combobox extends FormAssociatedCombobox {
    autocomplete: ComboboxAutocomplete | undefined;
    // @internal
    clickHandler(e: MouseEvent): boolean | void;
    // (undocumented)
    connectedCallback(): void;
    // @internal
    control: HTMLInputElement;
    // @internal
    disabledChanged(prev: boolean, next: boolean): void;
    filteredOptions: ListboxOption[];
    filterOptions(): void;
    // @internal
    focusoutHandler(e: FocusEvent): boolean | void;
    // @internal
    formResetCallback: () => void;
    // @internal
    inputHandler(e: InputEvent): boolean | void;
    // @internal
    keydownHandler(e: Event & KeyboardEvent): boolean | void;
    // @internal
    keyupHandler(e: KeyboardEvent): boolean | void;
    // @internal
    listboxId: string;
    // @internal
    maxHeight: number;
    open: boolean;
    // (undocumented)
    protected openChanged(): void;
    get options(): ListboxOption[];
    set options(value: ListboxOption[]);
    placeholder: string;
    // @internal
    protected placeholderChanged(): void;
    position: SelectPosition;
    positionAttribute: SelectPosition;
    role: SelectRole;
    // @internal
    selectedIndexChanged(prev: number, next: number): void;
    // @internal
    selectedOptionsChanged(prev: any, next: any): void;
    // @internal
    selectPreviousOption(): void;
    // @internal
    setDefaultSelectedOption(): void;
    setPositioning(): void;
    // @internal
    slottedOptionsChanged(prev: any, next: any): void;
    get value(): string;
    set value(next: string);
    }

// @internal
export interface Combobox extends StartEnd, DelegatesARIACombobox {
}

// @public
export enum ComboboxAutocomplete {
    // (undocumented)
    both = "both",
    // (undocumented)
    inline = "inline",
    // (undocumented)
    list = "list",
    // (undocumented)
    none = "none"
}

// @public
export type ComboboxOptions = FoundationElementDefinition & {
    indicator?: string | SyntheticViewTemplate;
};

// @public
export const comboboxTemplate: (context: ElementDefinitionContext, definition: ComboboxOptions) => ViewTemplate<Combobox>;

// @public
export interface ComponentPresentation {
    applyTo(element: FASTElement): void;
}

// @public
export const ComponentPresentation: Readonly<{
    define(tagName: string, presentation: ComponentPresentation, container: Container): void;
    forTag(tagName: string, element: HTMLElement): ComponentPresentation | null;
}>;

// @public
export function composedContains(reference: HTMLElement, test: HTMLElement): boolean;

// @public
export function composedParent<T extends HTMLElement>(element: T): HTMLElement | null;

// @alpha
export type ConstructableFormAssociated = Constructable<HTMLElement & FASTElement>;

// @public
export interface Container extends ServiceLocator {
    createChild(config?: Partial<Omit<ContainerConfiguration, "parentLocator">>): Container;
    getFactory<T extends Constructable>(key: T): Factory<T>;
    getResolver<K extends Key, T = K>(key: K | Key, autoRegister?: boolean): Resolver<T> | null;
    register(...params: any[]): Container;
    registerFactory<T extends Constructable>(key: T, factory: Factory<T>): void;
    registerResolver<K extends Key, T = K>(key: K, resolver: Resolver<T>): Resolver<T>;
    registerTransformer<K extends Key, T = K>(key: K, transformer: Transformer_2<T>): boolean;
}

// @public
export const Container: InterfaceSymbol<Container>;

// @public
export interface ContainerConfiguration {
    defaultResolver(key: Key, handler: Container): Resolver;
    parentLocator: ParentLocator;
    responsibleForOwnerRequests: boolean;
}

// @public
export const ContainerConfiguration: Readonly<{
    default: Readonly<ContainerConfiguration>;
}>;

// Warning: (ae-internal-missing-underscore) The name "ContainerImpl" should be prefixed with an underscore because the declaration is marked as @internal
//
// @internal (undocumented)
export class ContainerImpl implements Container {
    constructor(owner: any, config: ContainerConfiguration);
    // (undocumented)
    protected config: ContainerConfiguration;
    // (undocumented)
    createChild(config?: Partial<Omit<ContainerConfiguration, "parentLocator">>): Container;
    // (undocumented)
    get depth(): number;
    // (undocumented)
    get<K extends Key>(key: K): Resolved<K>;
    // (undocumented)
    getAll<K extends Key>(key: K, searchAncestors?: boolean): readonly Resolved<K>[];
    // (undocumented)
    getFactory<K extends Constructable>(Type: K): Factory<K>;
    // (undocumented)
    getResolver<K extends Key, T = K>(key: K | Key, autoRegister?: boolean): Resolver<T> | null;
    // (undocumented)
    has<K extends Key>(key: K, searchAncestors?: boolean): boolean;
    // (undocumented)
    protected owner: any;
    // (undocumented)
    get parent(): ContainerImpl | null;
    // (undocumented)
    register(...params: any[]): Container;
    // (undocumented)
    registerFactory<K extends Constructable>(key: K, factory: Factory<K>): void;
    // (undocumented)
    registerResolver<K extends Key, T = K>(key: K, resolver: Resolver<T>): Resolver<T>;
    // (undocumented)
    registerTransformer<K extends Key, T = K>(key: K, transformer: Transformer_2<T>): boolean;
    // (undocumented)
    get responsibleForOwnerRequests(): boolean;
}

// @public
export type ContextualElementDefinition = Omit<PartialFASTElementDefinition, "name">;

// @public
export interface CSSDesignToken<T extends string | number | boolean | BigInteger | null | Array<any> | symbol | ({
    createCSS?(): string;
} & Record<PropertyKey, any>)> extends DesignToken<T>, CSSDirective {
    readonly cssCustomProperty: string;
}

// @public
export type CSSDisplayPropertyValue = "block" | "contents" | "flex" | "grid" | "inherit" | "initial" | "inline" | "inline-block" | "inline-flex" | "inline-grid" | "inline-table" | "list-item" | "none" | "run-in" | "table" | "table-caption" | "table-cell" | "table-column" | "table-column-group" | "table-footer-group" | "table-header-group" | "table-row" | "table-row-group";

// @public
export const darkModeStylesheetBehavior: (styles: ElementStyles) => MatchMediaStyleSheetBehavior;

// @public
export class DataGrid extends FoundationElement {
    constructor();
    cellItemTemplate?: ViewTemplate;
    columnDefinitions: ColumnDefinition[] | null;
    // @internal (undocumented)
    connectedCallback(): void;
    // @internal
    defaultRowItemTemplate: ViewTemplate;
    // @internal (undocumented)
    disconnectedCallback(): void;
    focusColumnIndex: number;
    focusRowIndex: number;
    static generateColumns: (row: object) => ColumnDefinition[];
    generateHeader: GenerateHeaderOptions;
    gridTemplateColumns: string;
    // @internal (undocumented)
    handleFocus(e: FocusEvent): void;
    // @internal (undocumented)
    handleFocusOut(e: FocusEvent): void;
    // @internal (undocumented)
    handleKeydown(e: KeyboardEvent): void;
    // @internal (undocumented)
    handleRowFocus(e: Event): void;
    headerCellItemTemplate?: ViewTemplate;
    // @internal
    rowElements: HTMLElement[];
    rowElementTag: string;
    rowItemTemplate: ViewTemplate;
    rowsData: object[];
    }

// @public
export class DataGridCell extends FoundationElement {
    cellType: DataGridCellTypes;
    columnDefinition: ColumnDefinition | null;
    // @internal (undocumented)
    connectedCallback(): void;
    // @internal (undocumented)
    disconnectedCallback(): void;
    gridColumn: string;
    // (undocumented)
    handleFocusin(e: FocusEvent): void;
    // (undocumented)
    handleFocusout(e: FocusEvent): void;
    // (undocumented)
    handleKeydown(e: KeyboardEvent): void;
    rowData: object | null;
    }

// @public
export const dataGridCellTemplate: (context: ElementDefinitionContext, definition: FoundationElementDefinition) => ViewTemplate<DataGridCell>;

// @public
export enum DataGridCellTypes {
    // (undocumented)
    columnHeader = "columnheader",
    // (undocumented)
    default = "default"
}

// @public
export class DataGridRow extends FoundationElement {
    // @internal
    activeCellItemTemplate?: ViewTemplate;
    // @internal
    cellElements: HTMLElement[];
    cellItemTemplate?: ViewTemplate;
    columnDefinitions: ColumnDefinition[] | null;
    // @internal (undocumented)
    connectedCallback(): void;
    // @internal
    defaultCellItemTemplate?: ViewTemplate;
    // @internal
    defaultHeaderCellItemTemplate?: ViewTemplate;
    // @internal (undocumented)
    disconnectedCallback(): void;
    // @internal (undocumented)
    focusColumnIndex: number;
    gridTemplateColumns: string;
    // (undocumented)
    handleCellFocus(e: Event): void;
    // (undocumented)
    handleFocusout(e: FocusEvent): void;
    // (undocumented)
    handleKeydown(e: KeyboardEvent): void;
    headerCellItemTemplate?: ViewTemplate;
    // @internal
    isActiveRow: boolean;
    rowData: object | null;
    rowIndex: number;
    rowType: DataGridRowTypes;
    // @internal (undocumented)
    slottedCellElements: HTMLElement[];
    }

// @public
export const dataGridRowTemplate: (context: ElementDefinitionContext, definition: FoundationElementDefinition) => ViewTemplate<DataGridRow>;

// @public
export enum DataGridRowTypes {
    // (undocumented)
    default = "default",
    // (undocumented)
    header = "header",
    // (undocumented)
    stickyHeader = "sticky-header"
}

// @public
export const dataGridTemplate: (context: any, definition: any) => ViewTemplate<DataGrid>;

// @public
export class DefaultComponentPresentation implements ComponentPresentation {
    constructor(template?: ElementViewTemplate, styles?: ComposableStyles | ComposableStyles[]);
    applyTo(element: FASTElement): void;
    readonly styles: ElementStyles | null;
    readonly template: ElementViewTemplate | null;
}

// @public
export const DefaultResolver: Readonly<{
    none(key: Key): Resolver;
    singleton(key: Key): Resolver;
    transient(key: Key): Resolver;
}>;

// Warning: (ae-different-release-tags) This symbol has another declaration with a different release tag
// Warning: (ae-internal-mixed-release-tag) Mixed release tags are not allowed for "DelegatesARIAButton" because one of its declarations is marked as @internal
//
// @public
export class DelegatesARIAButton {
    ariaExpanded: "true" | "false" | undefined;
    ariaPressed: "true" | "false" | "mixed" | undefined;
}

// @internal
export interface DelegatesARIAButton extends ARIAGlobalStatesAndProperties {
}

// Warning: (ae-different-release-tags) This symbol has another declaration with a different release tag
// Warning: (ae-internal-mixed-release-tag) Mixed release tags are not allowed for "DelegatesARIACombobox" because one of its declarations is marked as @internal
//
// @public
export class DelegatesARIACombobox {
    ariaAutocomplete: "inline" | "list" | "both" | "none" | undefined;
}

// @internal
export interface DelegatesARIACombobox extends ARIAGlobalStatesAndProperties {
}

// Warning: (ae-different-release-tags) This symbol has another declaration with a different release tag
// Warning: (ae-internal-mixed-release-tag) Mixed release tags are not allowed for "DelegatesARIALink" because one of its declarations is marked as @internal
//
// @public
export class DelegatesARIALink {
    ariaExpanded: "true" | "false" | undefined;
}

// @internal
export interface DelegatesARIALink extends ARIAGlobalStatesAndProperties {
}

// Warning: (ae-different-release-tags) This symbol has another declaration with a different release tag
// Warning: (ae-internal-mixed-release-tag) Mixed release tags are not allowed for "DelegatesARIAListbox" because one of its declarations is marked as @internal
//
// @public
export class DelegatesARIAListbox {
    ariaActiveDescendant: string;
    ariaDisabled: "true" | "false";
    ariaExpanded: "true" | "false" | undefined;
}

// @internal
export interface DelegatesARIAListbox extends ARIAGlobalStatesAndProperties {
}

// Warning: (ae-different-release-tags) This symbol has another declaration with a different release tag
// Warning: (ae-internal-mixed-release-tag) Mixed release tags are not allowed for "DelegatesARIASelect" because one of its declarations is marked as @internal
//
// @public
export class DelegatesARIASelect {
    ariaExpanded: "true" | "false" | undefined;
    ariaPressed: "true" | "false" | "mixed" | undefined;
}

// @internal
export interface DelegatesARIASelect extends ARIAGlobalStatesAndProperties {
}

// Warning: (ae-different-release-tags) This symbol has another declaration with a different release tag
// Warning: (ae-internal-mixed-release-tag) Mixed release tags are not allowed for "DelegatesARIATextbox" because one of its declarations is marked as @internal
//
// @public
export class DelegatesARIATextbox {
}

// @internal
export interface DelegatesARIATextbox extends ARIAGlobalStatesAndProperties {
}

// Warning: (ae-different-release-tags) This symbol has another declaration with a different release tag
// Warning: (ae-internal-mixed-release-tag) Mixed release tags are not allowed for "DelegatesARIAToolbar" because one of its declarations is marked as @internal
//
// @public
export class DelegatesARIAToolbar {
    ariaLabel: string;
    ariaLabelledby: string;
}

// @internal
export interface DelegatesARIAToolbar extends ARIAGlobalStatesAndProperties {
}

// @public
export type DerivedDesignTokenValue<T> = T extends Function ? never : (target: HTMLElement) => T;

// @public
export interface DesignSystem {
    register(...params: any[]): DesignSystem;
    withElementDisambiguation(callback: ElementDisambiguationCallback): DesignSystem;
    withPrefix(prefix: string): DesignSystem;
    withShadowRootMode(mode: ShadowRootMode): DesignSystem;
}

// @public
export const DesignSystem: Readonly<{
    tagFor(type: Constructable): string;
    responsibleFor(element: HTMLElement): DesignSystem;
    getOrCreate(element?: HTMLElement): DesignSystem;
}>;

// @public
export interface DesignSystemRegistrationContext {
    readonly elementPrefix: string;
    tryDefineElement(name: string, type: Constructable, callback: ElementDefinitionCallback): any;
}

// @public
export const DesignSystemRegistrationContext: InterfaceSymbol<DesignSystemRegistrationContext>;

// @public
export interface DesignToken<T extends string | number | boolean | BigInteger | null | Array<any> | symbol | {}> {
    readonly appliedTo: HTMLElement[];
    deleteValueFor(element: HTMLElement): this;
    getValueFor(element: HTMLElement): StaticDesignTokenValue<T>;
    readonly name: string;
    setValueFor(element: HTMLElement, value: DesignTokenValue<T> | DesignToken<T>): void;
    subscribe(subscriber: DesignTokenSubscriber<this>, target?: HTMLElement): void;
    unsubscribe(subscriber: DesignTokenSubscriber<this>, target?: HTMLElement): void;
    withDefault(value: DesignTokenValue<T> | DesignToken<T>): this;
}

// @public
export const DesignToken: Readonly<{
    create: typeof create;
}>;

// @public
export interface DesignTokenChangeRecord<T extends DesignToken<any>> {
    target: HTMLElement;
    token: T;
}

// @public
export interface DesignTokenConfiguration {
    cssCustomPropertyName?: string | null;
    name: string;
}

// @public
export interface DesignTokenSubscriber<T extends DesignToken<any>> {
    // (undocumented)
    handleChange(record: DesignTokenChangeRecord<T>): void;
}

// @public
export type DesignTokenValue<T> = StaticDesignTokenValue<T> | DerivedDesignTokenValue<T>;

// @public
export const DI: Readonly<{
    createContainer(config?: Partial<ContainerConfiguration> | undefined): Container;
    findResponsibleContainer(node: Node): Container;
    findParentContainer(node: Node): Container;
    getOrCreateDOMContainer(node?: Node, config?: Partial<Pick<ContainerConfiguration, "responsibleForOwnerRequests" | "defaultResolver">> | undefined): Container;
    getDesignParamtypes: (Type: Constructable | Injectable) => readonly Key[] | undefined;
    getAnnotationParamtypes: (Type: Constructable | Injectable) => readonly Key[] | undefined;
    getOrCreateAnnotationParamTypes(Type: Constructable | Injectable): Key[];
    getDependencies(Type: Constructable | Injectable): Key[];
    defineProperty(target: {}, propertyName: string, key: Key, respectConnection?: boolean): void;
    createInterface<K extends Key>(nameConfigOrCallback?: string | InterfaceConfiguration | ((builder: ResolverBuilder<K>) => Resolver<K>) | undefined, configuror?: ((builder: ResolverBuilder<K>) => Resolver<K>) | undefined): InterfaceSymbol<K>;
    inject(...dependencies: Key[]): (target: any, key?: string | number | undefined, descriptor?: number | PropertyDescriptor | undefined) => void;
    transient<T extends Constructable<{}>>(target: T & Partial<RegisterSelf<T>>): T & RegisterSelf<T>;
    singleton<T_1 extends Constructable<{}>>(target: T_1 & Partial<RegisterSelf<T_1>>, options?: SingletonOptions): T_1 & RegisterSelf<T_1>;
}>;

// @public
export class Dialog extends FoundationElement {
    ariaDescribedby: string;
    ariaLabel: string;
    ariaLabelledby: string;
    // @internal (undocumented)
    connectedCallback(): void;
    // @internal (undocumented)
    dialog: HTMLDivElement;
    // @internal (undocumented)
    disconnectedCallback(): void;
    // @internal (undocumented)
    dismiss(): void;
    hidden: boolean;
    hide(): void;
    modal: boolean;
    show(): void;
    trapFocus: boolean;
    }

// @public
export const dialogTemplate: (context: ElementDefinitionContext, definition: FoundationElementDefinition) => ViewTemplate<Dialog>;

// @public
export const disabledCursor = "not-allowed";

// @public
export class Disclosure extends FoundationElement {
    // @internal (undocumented)
    connectedCallback(): void;
    // @internal (undocumented)
    details: HTMLDetailsElement;
    // @internal (undocumented)
    disconnectedCallback(): void;
    expanded: boolean;
    hide(): void;
    protected onToggle(): void;
    protected setup(): void;
    show(): void;
    title: string;
    toggle(): void;
}

// @public
export const disclosureTemplate: (context: ElementDefinitionContext, definition: FoundationElementDefinition) => ViewTemplate<Disclosure>;

// @public
export function display(displayValue: CSSDisplayPropertyValue): string;

// @public
export class Divider extends FoundationElement {
    role: DividerRole;
}

// @public
export enum DividerRole {
    presentation = "presentation",
    separator = "separator"
}

// @public
export const dividerTemplate: (context: ElementDefinitionContext, definition: FoundationElementDefinition) => ViewTemplate<Divider>;

// @public
export type ElementDefinitionCallback = (ctx: ElementDefinitionContext) => void;

// @public
export interface ElementDefinitionContext {
    readonly container: Container;
    defineElement(definition?: ContextualElementDefinition): void;
    definePresentation(presentation: ComponentPresentation): void;
    readonly name: string;
    readonly shadowRootMode: ShadowRootMode | undefined;
    tagFor(type: Constructable): string;
    readonly type: Constructable;
    readonly willDefine: boolean;
}

// @public
export type ElementDisambiguationCallback = (nameAttempt: string, typeAttempt: Constructable, existingType: Constructable) => string | null;

// @public
export const endTemplate: ViewTemplate<StartEnd>;

// @public
export interface Factory<T extends Constructable = any> {
    construct(container: Container, dynamicDependencies?: Key[]): Resolved<T>;
    registerTransformer(transformer: Transformer_2<T>): void;
    readonly Type: T;
}

// Warning: (ae-internal-missing-underscore) The name "FactoryImpl" should be prefixed with an underscore because the declaration is marked as @internal
//
// @internal (undocumented)
export class FactoryImpl<T extends Constructable = any> implements Factory<T> {
    constructor(Type: T, dependencies: Key[]);
    // (undocumented)
    construct(container: Container, dynamicDependencies?: Key[]): Resolved<T>;
    // (undocumented)
    registerTransformer(transformer: (instance: any) => any): void;
    // (undocumented)
    Type: T;
}

// @public
export class Flipper extends FoundationElement {
    direction: FlipperDirection;
    disabled: boolean;
    hiddenFromAT: boolean;
    keyupHandler(e: Event & KeyboardEvent): void;
}

// @public
export enum FlipperDirection {
    // (undocumented)
    next = "next",
    // (undocumented)
    previous = "previous"
}

// @public
export type FlipperOptions = FoundationElementDefinition & {
    next?: string | SyntheticViewTemplate;
    previous?: string | SyntheticViewTemplate;
};

// @public
export const flipperTemplate: (context: ElementDefinitionContext, definition: FlipperOptions) => ViewTemplate<Flipper>;

// @public
export const focusVisible: string;

// @public
export const forcedColorsStylesheetBehavior: (styles: ElementStyles) => MatchMediaStyleSheetBehavior;

// @alpha
export function FormAssociated<T extends ConstructableFormAssociated>(BaseCtor: T): T;

// Warning: (ae-forgotten-export) The symbol "ElementInternals" needs to be exported by the entry point index.d.ts
//
// @alpha
export interface FormAssociated extends Omit<ElementInternals, "labels"> {
    // (undocumented)
    attachProxy(): void;
    // (undocumented)
    detachProxy(): void;
    // (undocumented)
    dirtyValue: boolean;
    // (undocumented)
    disabled: boolean;
    // (undocumented)
    disabledChanged?(previous: boolean, next: boolean): void;
    // (undocumented)
    readonly elementInternals: ElementInternals | null;
    // (undocumented)
    readonly formAssociated: boolean;
    // (undocumented)
    formDisabledCallback?(disabled: boolean): void;
    // (undocumented)
    formResetCallback(): void;
    // (undocumented)
    initialValue: string;
    // (undocumented)
    initialValueChanged?(previous: any, next: any): void;
    // (undocumented)
    readonly labels: ReadonlyArray<Node[]>;
    // (undocumented)
    name: string;
    // (undocumented)
    nameChanged?(previous: any, next: any): void;
    // (undocumented)
    required: boolean;
    // (undocumented)
    requiredChanged(prev: boolean, next: boolean): void;
    // (undocumented)
    stopPropagation(e: Event): void;
    // (undocumented)
    validate(): void;
    // (undocumented)
    value: string;
    // (undocumented)
    valueChanged(previous: any, next: any): void;
}

// @alpha
export type FormAssociatedElement = FormAssociated & FASTElement & HTMLElement & FormAssociatedProxy;

// @alpha
export interface FormAssociatedProxy {
    // (undocumented)
    disabledChanged?(previous: boolean, next: boolean): void;
    // (undocumented)
    formDisabledCallback?(disabled: boolean): void;
    // (undocumented)
    formResetCallback?(): void;
    // (undocumented)
    initialValueChanged?(previous: any, next: any): void;
    // (undocumented)
    nameChanged?(previous: any, next: any): void;
    // (undocumented)
    proxy: ProxyElement;
    // (undocumented)
    valueChanged?(previous: any, next: any): void;
}

// @public
export class FoundationElement extends FASTElement {
    protected get $presentation(): ComponentPresentation | null;
    // Warning: (ae-incompatible-release-tags) The symbol "compose" is marked as @public, but its signature references "FoundationElementRegistry" which is marked as @internal
    static compose<T extends FoundationElementDefinition = FoundationElementDefinition, K extends Constructable<FoundationElement> = Constructable<FoundationElement>>(this: K, elementDefinition: T): (overrideDefinition?: OverrideFoundationElementDefinition<T>) => FoundationElementRegistry<T, K>;
    connectedCallback(): void;
    styles: ElementStyles | void | null;
    // (undocumented)
    protected stylesChanged(): void;
    template: ElementViewTemplate | void | null;
    // (undocumented)
    protected templateChanged(): void;
}

// @public
export interface FoundationElementDefinition {
    readonly attributes?: EagerOrLazyFoundationOption<(AttributeConfiguration | string)[], this>;
    baseName: string;
    readonly elementOptions?: EagerOrLazyFoundationOption<ElementDefinitionOptions, this>;
    readonly shadowOptions?: EagerOrLazyFoundationOption<Partial<ShadowRootInit> | null, this>;
    readonly styles?: EagerOrLazyFoundationOption<ComposableStyles | ComposableStyles[], this>;
    // Warning: (ae-forgotten-export) The symbol "EagerOrLazyFoundationOption" needs to be exported by the entry point index.d.ts
    readonly template?: EagerOrLazyFoundationOption<ElementViewTemplate, this>;
}

// Warning: (ae-internal-missing-underscore) The name "FoundationElementRegistry" should be prefixed with an underscore because the declaration is marked as @internal
//
// @internal
export class FoundationElementRegistry<TDefinition extends FoundationElementDefinition, TType> implements Registry {
    constructor(type: Constructable<FoundationElement>, elementDefinition: TDefinition, overrideDefinition: OverrideFoundationElementDefinition<TDefinition>);
    // (undocumented)
    readonly definition: OverrideFoundationElementDefinition<TDefinition>;
    // (undocumented)
    register(container: Container): void;
    // (undocumented)
    readonly type: Constructable<FoundationElement>;
}

// @public
export enum GenerateHeaderOptions {
    // (undocumented)
    default = "default",
    // (undocumented)
    none = "none",
    // (undocumented)
    sticky = "sticky"
}

// @public
export const getDirection: (rootNode: HTMLElement) => Direction;

// @public
export const hidden = ":host([hidden]){display:none}";

// @beta
export type HorizontalPosition = "start" | "end" | "left" | "right" | "unset";

// @public
export class HorizontalScroll extends FoundationElement {
    // (undocumented)
    connectedCallback(): void;
    // (undocumented)
    disconnectedCallback(): void;
    easing: ScrollEasing;
    flippersHiddenFromAT: boolean;
    keyupHandler(e: Event & KeyboardEvent): void;
    nextFlipperContainer: HTMLDivElement;
    previousFlipperContainer: HTMLDivElement;
    resized(): void;
    scrollContainer: HTMLDivElement;
    scrolled(): void;
    scrollItems: HTMLElement[];
    scrollItemsChanged(previous: any, next: any): void;
    scrollToNext(): void;
    scrollToPosition(newPosition: number, position?: number): void;
    scrollToPrevious(): void;
    speed: number;
    view: HorizontalScrollView;
    }

// @public
export type HorizontalScrollOptions = FoundationElementDefinition & {
    nextFlipper?: string | SyntheticViewTemplate;
    previousFlipper?: string | SyntheticViewTemplate;
};

// @public (undocumented)
export const horizontalScrollTemplate: (context: ElementDefinitionContext, definition: HorizontalScrollOptions) => ViewTemplate<HorizontalScroll>;

// @public
export type HorizontalScrollView = "default" | "mobile";

// @public
export function ignore(target: Injectable, property?: string | number, descriptor?: PropertyDescriptor | number): void;

// @public
export const inject: (...dependencies: Key[]) => (target: any, key?: string | number | undefined, descriptor?: number | PropertyDescriptor | undefined) => void;

// @public
export type Injectable<T = {}> = Constructable<T> & {
    inject?: Key[];
};

// @public
export interface InterfaceConfiguration {
    friendlyName?: string;
    respectConnection?: boolean;
}

// @public
export type InterfaceSymbol<K = any> = (target: any, property: string, index?: number) => void;

// @public
export function isListboxOption(el: Element): el is ListboxOption;

// @public
export function isTreeItemElement(el: Element): el is HTMLElement;

// @public
export type Key = PropertyKey | object | InterfaceSymbol | Constructable | Resolver;

// @public
export const lazy: (key: any) => any;

// @public
export const lightModeStylesheetBehavior: (styles: ElementStyles) => MatchMediaStyleSheetBehavior;

// Warning: (ae-different-release-tags) This symbol has another declaration with a different release tag
// Warning: (ae-internal-mixed-release-tag) Mixed release tags are not allowed for "Listbox" because one of its declarations is marked as @internal
//
// @public
export class Listbox extends FoundationElement {
    // @internal
    clickHandler(e: MouseEvent): boolean | void;
    disabled: boolean;
    // @internal (undocumented)
    get firstSelectedOption(): ListboxOption;
    // @internal (undocumented)
    protected focusAndScrollOptionIntoView(): void;
    // @internal (undocumented)
    focusinHandler(e: FocusEvent): void;
    handleTypeAhead: (key: string) => void;
    // @internal
    keydownHandler(e: KeyboardEvent): boolean | void;
    // (undocumented)
    get length(): number;
    // @internal
    mousedownHandler(e: MouseEvent): boolean | void;
    get options(): ListboxOption[];
    set options(value: ListboxOption[]);
    // @internal
    protected _options: ListboxOption[];
    role: string;
    selectedIndex: number;
    // (undocumented)
    selectedIndexChanged(prev: number, next: number): void;
    selectedOptions: ListboxOption[];
    // (undocumented)
    protected selectedOptionsChanged(prev: any, next: any): void;
    selectFirstOption(): void;
    // @internal
    selectLastOption(): void;
    // @internal
    selectNextOption(): void;
    // @internal
    selectPreviousOption(): void;
    // @internal (undocumented)
    protected setDefaultSelectedOption(): void;
    protected setSelectedOptions(): void;
    static slottedOptionFilter: (n: HTMLElement) => boolean;
    // @internal (undocumented)
    slottedOptions: HTMLElement[];
    // (undocumented)
    slottedOptionsChanged(prev: any, next: any): void;
    // @internal
    protected static readonly TYPE_AHEAD_TIMEOUT_MS = 1000;
    // @internal (undocumented)
    protected typeaheadBuffer: string;
    // (undocumented)
    typeaheadBufferChanged(prev: string, next: string): void;
    // @internal
    protected typeAheadExpired: boolean;
    // @internal (undocumented)
    protected typeaheadTimeout: number;
}

// @internal (undocumented)
export interface Listbox extends DelegatesARIAListbox {
}

// Warning: (ae-different-release-tags) This symbol has another declaration with a different release tag
// Warning: (ae-internal-mixed-release-tag) Mixed release tags are not allowed for "ListboxOption" because one of its declarations is marked as @internal
//
// @public
export class ListboxOption extends FoundationElement {
    constructor(text?: string, value?: string, defaultSelected?: boolean, selected?: boolean);
    defaultSelected: boolean;
    // (undocumented)
    protected defaultSelectedChanged(): void;
    dirtyValue: boolean;
    disabled: boolean;
    // (undocumented)
    protected disabledChanged(prev: any, next: any): void;
    // (undocumented)
    get form(): HTMLFormElement | null;
    protected initialValue: string;
    // (undocumented)
    initialValueChanged(previous: string, next: string): void;
    // (undocumented)
    get label(): string;
    // @internal (undocumented)
    proxy: HTMLOptionElement;
    selected: boolean;
    selectedAttribute: boolean;
    // (undocumented)
    protected selectedAttributeChanged(): void;
    // (undocumented)
    protected selectedChanged(): void;
    // (undocumented)
    get text(): string;
    set value(next: string);
    // (undocumented)
    get value(): string;
    }

// @internal (undocumented)
export interface ListboxOption extends StartEnd {
}

// @public
export const listboxOptionTemplate: (context: ElementDefinitionContext, definition: FoundationElementDefinition) => ViewTemplate<ListboxOption>;

// @public
export enum ListboxRole {
    // (undocumented)
    listbox = "listbox"
}

// @public
export const listboxTemplate: (context: ElementDefinitionContext, definition: FoundationElementDefinition) => ViewTemplate<Listbox>;

// @public
export abstract class MatchMediaBehavior implements Behavior {
    constructor(query: MediaQueryList);
    bind(source: typeof FASTElement & HTMLElement): void;
    protected abstract constructListener(source: typeof FASTElement): MediaQueryListListener;
    readonly query: MediaQueryList;
    unbind(source: typeof FASTElement & HTMLElement): void;
}

// @public
export class MatchMediaStyleSheetBehavior extends MatchMediaBehavior {
    constructor(query: MediaQueryList, styles: ElementStyles);
    // @internal
    protected constructListener(source: typeof FASTElement): MediaQueryListListener;
    readonly query: MediaQueryList;
    readonly styles: ElementStyles;
    // @internal
    unbind(source: typeof FASTElement & HTMLElement): void;
    static with(query: MediaQueryList): (styles: ElementStyles) => MatchMediaStyleSheetBehavior;
}

// @public
export type MediaQueryListListener = (this: MediaQueryList, ev?: MediaQueryListEvent) => void;

// @public
export class Menu extends FoundationElement {
    collapseExpandedItem(): void;
    // @internal (undocumented)
    connectedCallback(): void;
    // @internal (undocumented)
    disconnectedCallback(): void;
    focus(): void;
    // @internal
    handleFocusOut: (e: FocusEvent) => void;
    // @internal (undocumented)
    handleMenuKeyDown(e: KeyboardEvent): void | boolean;
    // @internal (undocumented)
    readonly isNestedMenu: () => boolean;
    // @internal (undocumented)
    items: HTMLSlotElement;
    }

// Warning: (ae-different-release-tags) This symbol has another declaration with a different release tag
// Warning: (ae-internal-mixed-release-tag) Mixed release tags are not allowed for "MenuItem" because one of its declarations is marked as @internal
//
// @public
export class MenuItem extends FoundationElement {
    checked: boolean;
    // @internal (undocumented)
    connectedCallback(): void;
    // @internal
    currentDirection: Direction;
    disabled: boolean;
    // @internal (undocumented)
    disconnectedCallback(): void;
    expanded: boolean;
    // @internal (undocumented)
    handleMenuItemClick: (e: MouseEvent) => boolean;
    // @internal (undocumented)
    handleMenuItemKeyDown: (e: KeyboardEvent) => boolean;
    // @internal (undocumented)
    handleMouseOut: (e: MouseEvent) => boolean;
    // @internal (undocumented)
    handleMouseOver: (e: MouseEvent) => boolean;
    // @internal (undocumented)
    hasSubmenu: boolean;
    role: MenuItemRole;
    // @internal (undocumented)
    startColumnCount: MenuItemColumnCount;
    // @internal (undocumented)
    submenu: Element | undefined;
    // @internal (undocumented)
    submenuLoaded: () => void;
    // @internal
    submenuRegion: AnchoredRegion;
    }

// @internal
export interface MenuItem extends StartEnd {
}

// @public
export type MenuItemColumnCount = 0 | 1 | 2;

// @public
export type MenuItemOptions = FoundationElementDefinition & {
    checkboxIndicator?: string | SyntheticViewTemplate;
    expandCollapseGlyph?: string | SyntheticViewTemplate;
    radioIndicator?: string | SyntheticViewTemplate;
};

// @public
export enum MenuItemRole {
    menuitem = "menuitem",
    menuitemcheckbox = "menuitemcheckbox",
    menuitemradio = "menuitemradio"
}

// @public
export const menuItemTemplate: (context: ElementDefinitionContext, definition: MenuItemOptions) => ViewTemplate<MenuItem>;

// @public
export const menuTemplate: (context: ElementDefinitionContext, definition: FoundationElementDefinition) => ViewTemplate<Menu>;

// @public
export const newInstanceForScope: (key: any) => any;

// @public
export const newInstanceOf: (key: any) => any;

// Warning: (ae-different-release-tags) This symbol has another declaration with a different release tag
// Warning: (ae-forgotten-export) The symbol "FormAssociatedNumberField" needs to be exported by the entry point index.d.ts
// Warning: (ae-internal-mixed-release-tag) Mixed release tags are not allowed for "NumberField" because one of its declarations is marked as @internal
//
// @public
export class NumberField extends FormAssociatedNumberField {
    autofocus: boolean;
    // @internal (undocumented)
    connectedCallback(): void;
    // @internal
    control: HTMLInputElement;
    // @internal (undocumented)
    defaultSlottedNodes: Node[];
    // @internal
    handleChange(): void;
    // @internal
    handleTextInput(): void;
    hideStep: boolean;
    list: string;
    max: number;
    // (undocumented)
    maxChanged(previousValue: any, nextValue: any): void;
    maxlength: number;
    min: number;
    // (undocumented)
    minChanged(previousValue: any, nextValue: any): void;
    minlength: number;
    placeholder: string;
    readOnly: boolean;
    size: number;
    step: number;
    stepDown(): void;
    stepUp(): void;
    // (undocumented)
    valueChanged(previousValue: any, nextValue: any): void;
}

// @internal
export interface NumberField extends StartEnd, DelegatesARIATextbox {
}

// @public
export type NumberFieldOptions = FoundationElementDefinition & {
    stepDownGlyph?: string | SyntheticViewTemplate;
    stepUpGlyph?: string | SyntheticViewTemplate;
};

// @public
export const numberFieldTemplate: (context: ElementDefinitionContext, definition: NumberFieldOptions) => ViewTemplate<NumberField>;

// @public
export const optional: (key: any) => any;

// @public
export type OverrideFoundationElementDefinition<T extends FoundationElementDefinition> = Partial<Omit<T, "type">> & {
    prefix?: string;
};

// @public
export type ParentLocator = (owner: any) => Container | null;

// @public
export type ProgressOptions = FoundationElementDefinition & {
    indeterminateIndicator1?: string | SyntheticViewTemplate;
    indeterminateIndicator2?: string | SyntheticViewTemplate;
};

// @public
export type ProgressRingOptions = FoundationElementDefinition & {
    indeterminateIndicator?: string | SyntheticViewTemplate;
};

// @public
export const progressRingTemplate: (context: ElementDefinitionContext, definition: ProgressRingOptions) => ViewTemplate<BaseProgress>;

// @public
export const progressTemplate: (context: ElementDefinitionContext, defintion: ProgressOptions) => ViewTemplate<BaseProgress>;

// @public
export class PropertyStyleSheetBehavior implements Behavior {
    constructor(propertyName: string, value: any, styles: ElementStyles);
    bind(elementInstance: FASTElement): void;
    // @internal
    handleChange(source: FASTElement, key: any): void;
    // @internal
    unbind(source: typeof FASTElement & HTMLElement): void;
    }

// @alpha
export type ProxyElement = HTMLSelectElement | HTMLTextAreaElement | HTMLInputElement;

// Warning: (ae-forgotten-export) The symbol "FormAssociatedRadio" needs to be exported by the entry point index.d.ts
//
// @public
export class Radio extends FormAssociatedRadio implements RadioControl {
    constructor();
    checked: boolean;
    checkedAttribute: boolean;
    // @internal (undocumented)
    clickHandler: (e: MouseEvent) => void;
    // @internal (undocumented)
    connectedCallback(): void;
    defaultChecked: boolean | undefined;
    // @internal (undocumented)
    defaultSlottedNodes: Node[];
    // @internal (undocumented)
    formResetCallback: () => void;
    // @internal
    initialValue: string;
    // @internal (undocumented)
    keypressHandler: (e: KeyboardEvent) => boolean | void;
    name: string;
    readOnly: boolean;
    }

// @public
export type RadioControl = Pick<HTMLInputElement, "checked" | "disabled" | "readOnly" | "focus" | "setAttribute" | "getAttribute">;

// @public
export class RadioGroup extends FoundationElement {
    // (undocumented)
    childItems: HTMLElement[];
    // @internal (undocumented)
    clickHandler: (e: MouseEvent) => void;
    // @internal (undocumented)
    connectedCallback(): void;
    disabled: boolean;
    // (undocumented)
    disconnectedCallback(): void;
    // @internal (undocumented)
    focusOutHandler: (e: FocusEvent) => boolean | void;
    // @internal
    keydownHandler: (e: KeyboardEvent) => boolean | void;
    name: string;
    // (undocumented)
    protected nameChanged(): void;
    orientation: Orientation;
    readOnly: boolean;
    // @internal (undocumented)
    slottedRadioButtons: HTMLElement[];
    value: string;
    // (undocumented)
    protected valueChanged(): void;
}

// @public
export const radioGroupTemplate: (context: ElementDefinitionContext, definition: FoundationElementDefinition) => ViewTemplate<RadioGroup>;

// @public
export type RadioOptions = FoundationElementDefinition & {
    checkedIndicator?: string | SyntheticViewTemplate;
};

// @public
export const radioTemplate: (context: ElementDefinitionContext, definition: RadioOptions) => ViewTemplate<Radio>;

// @public
export type RegisterSelf<T extends Constructable> = {
    register(container: Container): Resolver<InstanceType<T>>;
    registerInRequestor: boolean;
};

// @public
export interface Registration<K = any> {
    register(container: Container, key?: Key): Resolver<K>;
}

// @public
export const Registration: Readonly<{
    instance<T>(key: Key, value: T): Registration<T>;
    singleton<T_1 extends Constructable<{}>>(key: Key, value: T_1): Registration<InstanceType<T_1>>;
    transient<T_2 extends Constructable<{}>>(key: Key, value: T_2): Registration<InstanceType<T_2>>;
    callback<T_3>(key: Key, callback: ResolveCallback<T_3>): Registration<Resolved<T_3>>;
    cachedCallback<T_4>(key: Key, callback: ResolveCallback<T_4>): Registration<Resolved<T_4>>;
    aliasTo<T_5>(originalKey: T_5, aliasKey: Key): Registration<Resolved<T_5>>;
}>;

// @public
export interface Registry {
    register(container: Container, ...params: unknown[]): void | Resolver;
}

// @public
export type ResolveCallback<T = any> = (handler: Container, requestor: Container, resolver: Resolver<T>) => T;

// Warning: (ae-forgotten-export) The symbol "ResolverLike" needs to be exported by the entry point index.d.ts
//
// @public
export type Resolved<K> = K extends InterfaceSymbol<infer T> ? T : K extends Constructable ? InstanceType<K> : K extends ResolverLike<any, infer T1> ? T1 extends Constructable ? InstanceType<T1> : T1 : K;

// @public
export interface Resolver<K = any> extends ResolverLike<Container, K> {
}

// @public
export class ResolverBuilder<K> {
    constructor(container: Container, key: Key);
    aliasTo(destinationKey: Key): Resolver<K>;
    cachedCallback(value: ResolveCallback<K>): Resolver<K>;
    callback(value: ResolveCallback<K>): Resolver<K>;
    instance(value: K): Resolver<K>;
    singleton(value: Constructable): Resolver<K>;
    transient(value: Constructable): Resolver<K>;
}

// Warning: (ae-internal-missing-underscore) The name "ResolverImpl" should be prefixed with an underscore because the declaration is marked as @internal
//
// @internal (undocumented)
export class ResolverImpl implements Resolver, Registration {
    // (undocumented)
    get $isResolver(): true;
    constructor(key: Key, strategy: ResolverStrategy, state: any);
    // (undocumented)
    getFactory(container: Container): Factory | null;
    // (undocumented)
    key: Key;
    // (undocumented)
    register(container: Container, key?: Key): Resolver;
    // (undocumented)
    resolve(handler: Container, requestor: Container): any;
    // (undocumented)
    state: any;
    // (undocumented)
    strategy: ResolverStrategy;
}

// Warning: (ae-internal-missing-underscore) The name "ResolverStrategy" should be prefixed with an underscore because the declaration is marked as @internal
//
// @internal (undocumented)
export const enum ResolverStrategy {
    // (undocumented)
    alias = 5,
    // (undocumented)
    array = 4,
    // (undocumented)
    callback = 3,
    // (undocumented)
    instance = 0,
    // (undocumented)
    singleton = 1,
    // (undocumented)
    transient = 2
}

// @public
export type ScrollEasing = "linear" | "ease-in" | "ease-out" | "ease-in-out";

// Warning: (ae-different-release-tags) This symbol has another declaration with a different release tag
// Warning: (ae-forgotten-export) The symbol "FormAssociatedSelect" needs to be exported by the entry point index.d.ts
// Warning: (ae-internal-mixed-release-tag) Mixed release tags are not allowed for "Select" because one of its declarations is marked as @internal
//
// @public
export class Select extends FormAssociatedSelect {
    // @internal
    clickHandler(e: MouseEvent): boolean | void;
    // (undocumented)
    connectedCallback(): void;
    // @internal
    disabledChanged(prev: boolean, next: boolean): void;
    displayValue: string;
    // @internal
    focusoutHandler(e: FocusEvent): boolean | void;
    // @internal
    formResetCallback: () => void;
    // @internal
    keydownHandler(e: KeyboardEvent): boolean | void;
    // @internal
    maxHeight: number;
    // @internal
    open: boolean;
    // (undocumented)
    protected openChanged(): void;
    position: SelectPosition;
    positionAttribute: SelectPosition;
    role: SelectRole;
    // @internal
    selectedIndexChanged(prev: any, next: any): void;
    setPositioning(): void;
    // @internal
    slottedOptionsChanged(prev: any, next: any): void;
    get value(): string;
    set value(next: string);
    }

// @internal (undocumented)
export interface Select extends StartEnd, DelegatesARIASelect {
}

// @public
export type SelectOptions = FoundationElementDefinition & {
    indicator?: string | SyntheticViewTemplate;
};

// @public
export enum SelectPosition {
    // (undocumented)
    above = "above",
    // (undocumented)
    below = "below"
}

// @public
export enum SelectRole {
    // (undocumented)
    combobox = "combobox"
}

// @public
export const selectTemplate: (context: ElementDefinitionContext, definition: SelectOptions) => ViewTemplate<Select>;

// @public
export interface ServiceLocator {
    get<K extends Key>(key: K): Resolved<K>;
    get<K extends Key>(key: Key): Resolved<K>;
    get<K extends Key>(key: K | Key): Resolved<K>;
    getAll<K extends Key>(key: K, searchAncestors?: boolean): readonly Resolved<K>[];
    getAll<K extends Key>(key: Key, searchAncestors?: boolean): readonly Resolved<K>[];
    getAll<K extends Key>(key: K | Key, searchAncestors?: boolean): readonly Resolved<K>[];
    has<K extends Key>(key: K | Key, searchAncestors: boolean): boolean;
}

// @public
export const ServiceLocator: InterfaceSymbol<ServiceLocator>;

// Warning: (ae-forgotten-export) The symbol "singletonDecorator" needs to be exported by the entry point index.d.ts
//
// @public
export function singleton<T extends Constructable>(): typeof singletonDecorator;

// @public (undocumented)
export function singleton<T extends Constructable>(options?: SingletonOptions): typeof singletonDecorator;

// @public
export function singleton<T extends Constructable>(target: T & Partial<RegisterSelf<T>>): T & RegisterSelf<T>;

// @public
export class Skeleton extends FoundationElement {
    fill: string;
    pattern: string;
    shape: SkeletonShape;
    shimmer: boolean;
}

// @public
export type SkeletonShape = "rect" | "circle";

// @public
export const skeletonTemplate: (context: ElementDefinitionContext, definition: FoundationElementDefinition) => ViewTemplate<Skeleton>;

// Warning: (ae-forgotten-export) The symbol "FormAssociatedSlider" needs to be exported by the entry point index.d.ts
//
// @public
export class Slider extends FormAssociatedSlider implements SliderConfiguration {
    // @internal (undocumented)
    connectedCallback(): void;
    decrement(): void;
    // @internal (undocumented)
    direction: Direction;
    // @internal (undocumented)
    disconnectedCallback(): void;
    increment(): void;
    // @internal (undocumented)
    initialValue: string;
    // @internal (undocumented)
    isDragging: boolean;
    // (undocumented)
    protected keypressHandler: (e: KeyboardEvent) => void;
    max: number;
    min: number;
    mode: SliderMode;
    orientation: Orientation;
    // @internal (undocumented)
    position: string;
    readOnly: boolean;
    step: number;
    // @internal (undocumented)
    stepMultiplier: number;
    // @internal (undocumented)
    thumb: HTMLDivElement;
    // @internal (undocumented)
    track: HTMLDivElement;
    // @internal (undocumented)
    trackHeight: number;
    // @internal (undocumented)
    trackLeft: number;
    // @internal (undocumented)
    trackMinHeight: number;
    // @internal (undocumented)
    trackMinWidth: number;
    // @internal (undocumented)
    trackWidth: number;
    // @internal (undocumented)
    valueChanged(previous: any, next: any): void;
    valueTextFormatter: (value: string) => string | null;
}

// @public
export interface SliderConfiguration {
    // (undocumented)
    direction?: Direction;
    // (undocumented)
    disabled?: boolean;
    // (undocumented)
    max: number;
    // (undocumented)
    min: number;
    // (undocumented)
    orientation?: Orientation;
}

// @public
export class SliderLabel extends FoundationElement {
    // @internal (undocumented)
    connectedCallback(): void;
    disabled: boolean;
    // @internal (undocumented)
    disconnectedCallback(): void;
    // @internal (undocumented)
    handleChange(source: any, propertyName: string): void;
    hideMark: boolean;
    position: string;
    // @internal (undocumented)
    positionStyle: string;
    // @internal (undocumented)
    root: HTMLDivElement;
    // @internal (undocumented)
    sliderDirection: Direction;
    // @internal (undocumented)
    sliderMaxPosition: number;
    // @internal (undocumented)
    sliderMinPosition: number;
    // @internal (undocumented)
    sliderOrientation: Orientation;
    // @internal (undocumented)
    protected sliderOrientationChanged(): void;
}

// @public
export const sliderLabelTemplate: (context: ElementDefinitionContext, definition: FoundationElementDefinition) => ViewTemplate<SliderLabel>;

// @public
export enum SliderMode {
    // (undocumented)
    singleValue = "single-value"
}

// @public
export type SliderOptions = FoundationElementDefinition & {
    thumb?: string | SyntheticViewTemplate;
};

// @public
export const sliderTemplate: (context: ElementDefinitionContext, definition: SliderOptions) => ViewTemplate<Slider>;

// @public
export class StartEnd {
    // (undocumented)
    end: HTMLSlotElement;
    // (undocumented)
    endContainer: HTMLSpanElement;
    // (undocumented)
    handleEndContentChange(): void;
    // (undocumented)
    handleStartContentChange(): void;
    // (undocumented)
    start: HTMLSlotElement;
    // (undocumented)
    startContainer: HTMLSpanElement;
}

// @public
export const startTemplate: ViewTemplate<StartEnd>;

// @public
export type StaticDesignTokenValue<T> = T extends Function ? never : T;

// @alpha (undocumented)
export const supportsElementInternals: boolean;

// Warning: (ae-forgotten-export) The symbol "FormAssociatedSwitch" needs to be exported by the entry point index.d.ts
//
// @public
export class Switch extends FormAssociatedSwitch {
    constructor();
    checked: boolean;
    checkedAttribute: boolean;
    // @internal (undocumented)
    clickHandler: (e: MouseEvent) => void;
    // @internal (undocumented)
    connectedCallback(): void;
    defaultChecked: boolean;
    // @internal (undocumented)
    defaultSlottedNodes: Node[];
    // @internal (undocumented)
    formResetCallback: () => void;
    // @internal
    initialValue: string;
    // @internal (undocumented)
    keypressHandler: (e: KeyboardEvent) => void;
    readOnly: boolean;
    }

// @public
export type SwitchOptions = FoundationElementDefinition & {
    switch?: string | SyntheticViewTemplate;
};

// @public
export const switchTemplate: (context: ElementDefinitionContext, definition: SwitchOptions) => ViewTemplate<Switch>;

// @public
export class Tab extends FoundationElement {
    disabled: boolean;
}

// @public
export class TabPanel extends FoundationElement {
}

// @public
export const tabPanelTemplate: (context: ElementDefinitionContext, definition: FoundationElementDefinition) => ViewTemplate<TabPanel>;

// Warning: (ae-different-release-tags) This symbol has another declaration with a different release tag
// Warning: (ae-internal-mixed-release-tag) Mixed release tags are not allowed for "Tabs" because one of its declarations is marked as @internal
//
// @public
export class Tabs extends FoundationElement {
    activeid: string;
    // @internal (undocumented)
    activeidChanged(): void;
    activeindicator: boolean;
    // @internal (undocumented)
    activeIndicatorRef: HTMLElement;
    activetab: HTMLElement;
    adjust(adjustment: number): void;
    // @internal (undocumented)
    connectedCallback(): void;
    orientation: TabsOrientation;
    // @internal (undocumented)
    showActiveIndicator: boolean;
    // @internal (undocumented)
    tabpanels: HTMLElement[];
    // @internal (undocumented)
    tabpanelsChanged(): void;
    // @internal (undocumented)
    tabs: HTMLElement[];
    // @internal (undocumented)
    tabsChanged(): void;
    }

// @internal
export interface Tabs extends StartEnd {
}

// @public
export enum TabsOrientation {
    // (undocumented)
    horizontal = "horizontal",
    // (undocumented)
    vertical = "vertical"
}

// @public
export const tabsTemplate: (context: ElementDefinitionContext, definition: FoundationElementDefinition) => ViewTemplate<Tabs>;

// @public
export const tabTemplate: (context: ElementDefinitionContext, definition: FoundationElementDefinition) => ViewTemplate<Tab>;

// Warning: (ae-different-release-tags) This symbol has another declaration with a different release tag
// Warning: (ae-forgotten-export) The symbol "FormAssociatedTextArea" needs to be exported by the entry point index.d.ts
// Warning: (ae-internal-mixed-release-tag) Mixed release tags are not allowed for "TextArea" because one of its declarations is marked as @internal
//
// @public
export class TextArea extends FormAssociatedTextArea {
    autofocus: boolean;
    cols: number;
    // @internal
    control: HTMLTextAreaElement;
    // @internal (undocumented)
    defaultSlottedNodes: Node[];
    formId: string;
    // @internal
    handleChange(): void;
    // @internal (undocumented)
    handleTextInput: () => void;
    list: string;
    maxlength: number;
    minlength: number;
    name: string;
    placeholder: string;
    readOnly: boolean;
    resize: TextAreaResize;
    rows: number;
    spellcheck: boolean;
    }

// @internal
export interface TextArea extends DelegatesARIATextbox {
}

// @public
export enum TextAreaResize {
    both = "both",
    horizontal = "horizontal",
    none = "none",
    vertical = "vertical"
}

// @public
export const textAreaTemplate: (context: ElementDefinitionContext, definition: FoundationElementDefinition) => ViewTemplate<TextArea>;

// Warning: (ae-different-release-tags) This symbol has another declaration with a different release tag
// Warning: (ae-forgotten-export) The symbol "FormAssociatedTextField" needs to be exported by the entry point index.d.ts
// Warning: (ae-internal-mixed-release-tag) Mixed release tags are not allowed for "TextField" because one of its declarations is marked as @internal
//
// @public
export class TextField extends FormAssociatedTextField {
    autofocus: boolean;
    // @internal (undocumented)
    connectedCallback(): void;
    // @internal
    control: HTMLInputElement;
    // @internal (undocumented)
    defaultSlottedNodes: Node[];
    // @internal
    handleChange(): void;
    // @internal
    handleTextInput(): void;
    list: string;
    maxlength: number;
    minlength: number;
    pattern: string;
    placeholder: string;
    readOnly: boolean;
    size: number;
    spellcheck: boolean;
    type: TextFieldType;
    }

// @internal
export interface TextField extends StartEnd, DelegatesARIATextbox {
}

// @public
export const textFieldTemplate: (context: ElementDefinitionContext, definition: FoundationElementDefinition) => ViewTemplate<TextField>;

// @public
export enum TextFieldType {
    email = "email",
    password = "password",
    tel = "tel",
    text = "text",
    url = "url"
}

// Warning: (ae-different-release-tags) This symbol has another declaration with a different release tag
// Warning: (ae-internal-mixed-release-tag) Mixed release tags are not allowed for "Toolbar" because one of its declarations is marked as @internal
//
// @public
export class Toolbar extends FoundationElement {
    // @internal
    get activeIndex(): number;
    set activeIndex(value: number);
    // @internal
    clickHandler(e: MouseEvent): boolean | void;
    // @internal (undocumented)
    connectedCallback(): void;
    // @internal
    direction: Direction;
    // @internal
    focusinHandler(e: FocusEvent): boolean | void;
    // @internal
    keydownHandler(e: KeyboardEvent): boolean | void;
    orientation: Orientation;
    // @internal
    slottedItems: HTMLElement[];
    // @internal
    protected slottedItemsChanged(prev: unknown, next: HTMLElement[]): void;
    // @internal
    slottedLabel: HTMLElement[];
}

// @internal (undocumented)
export interface Toolbar extends StartEnd, DelegatesARIAToolbar {
}

// @public
export const toolbarTemplate: (context: ElementDefinitionContext, definition: FoundationElementDefinition) => ViewTemplate<Toolbar>;

// @public
export class Tooltip extends FoundationElement {
    anchor: string;
    anchorElement: HTMLElement | null;
    // (undocumented)
    connectedCallback(): void;
    // @internal
    currentDirection: Direction;
    delay: number;
    // (undocumented)
    disconnectedCallback(): void;
    // @internal
    handlePositionChange: (ev: Event) => void;
    // @internal (undocumented)
    horizontalDefaultPosition: string | undefined;
    // @internal (undocumented)
    horizontalInset: string;
    // @internal (undocumented)
    horizontalPositioningMode: AxisPositioningMode;
    // @internal (undocumented)
    horizontalScaling: AxisScalingMode;
    position: TooltipPosition;
    // @internal
    region: AnchoredRegion;
    // @internal (undocumented)
    tooltipVisible: boolean;
    // @internal (undocumented)
    verticalDefaultPosition: string | undefined;
    // @internal (undocumented)
    verticalInset: string;
    // @internal (undocumented)
    verticalPositioningMode: AxisPositioningMode;
    // @internal (undocumented)
    verticalScaling: AxisScalingMode;
    // @internal
    viewportElement: HTMLElement | null;
    visible: boolean;
    }

// @public
export enum TooltipPosition {
    bottom = "bottom",
    end = "end",
    left = "left",
    right = "right",
    start = "start",
    top = "top"
}

// @public
export const tooltipTemplate: (context: ElementDefinitionContext, definition: FoundationElementDefinition) => ViewTemplate;

// @public
type Transformer_2<K> = (instance: Resolved<K>) => Resolved<K>;

export { Transformer_2 as Transformer }

// Warning: (ae-forgotten-export) The symbol "transientDecorator" needs to be exported by the entry point index.d.ts
//
// @public
export function transient<T extends Constructable>(): typeof transientDecorator;

// @public
export function transient<T extends Constructable>(target: T & Partial<RegisterSelf<T>>): T & RegisterSelf<T>;

// Warning: (ae-different-release-tags) This symbol has another declaration with a different release tag
// Warning: (ae-internal-mixed-release-tag) Mixed release tags are not allowed for "TreeItem" because one of its declarations is marked as @internal
//
// @public
export class TreeItem extends FoundationElement {
    // (undocumented)
    childItemLength(): number;
    // (undocumented)
    childItems: HTMLElement[];
    // @internal (undocumented)
    connectedCallback(): void;
    disabled: boolean;
    // @internal (undocumented)
    disconnectedCallback(): void;
    // (undocumented)
    expandCollapseButton: HTMLDivElement;
    expanded: boolean;
    // (undocumented)
    focusable: boolean;
    static focusItem(el: HTMLElement): void;
    // (undocumented)
    handleChange(source: any, propertyName: string): void;
    // (undocumented)
    handleClick: (e: MouseEvent) => void;
    // (undocumented)
    handleExpandCollapseButtonClick: (e: MouseEvent) => void;
    handleKeyDown: (e: KeyboardEvent) => void | boolean;
    // (undocumented)
    readonly isNestedItem: () => boolean;
    // (undocumented)
    items: HTMLElement[];
    // @internal (undocumented)
    nested: boolean;
    // (undocumented)
    renderCollapsedChildren: boolean;
    selected: boolean;
    }

// @internal
export interface TreeItem extends StartEnd {
}

// @public
export type TreeItemOptions = FoundationElementDefinition & {
    expandCollapseGlyph?: string | SyntheticViewTemplate;
};

// @public
export const treeItemTemplate: (context: ElementDefinitionContext, definition: TreeItemOptions) => ViewTemplate<TreeItem>;

// @public
export class TreeView extends FoundationElement {
    // (undocumented)
    connectedCallback(): void;
    // (undocumented)
    currentSelected: HTMLElement | TreeItem | null;
    // (undocumented)
    handleBlur: (e: FocusEvent) => void;
    // (undocumented)
    handleKeyDown: (e: KeyboardEvent) => void | boolean;
    // (undocumented)
    renderCollapsedNodes: boolean;
    // (undocumented)
    slottedTreeItems: HTMLElement[];
    // (undocumented)
    treeView: HTMLElement;
}

// @public
export const treeViewTemplate: (context: ElementDefinitionContext, definition: FoundationElementDefinition) => ViewTemplate<TreeView>;

// Warning: (ae-internal-missing-underscore) The name "validateKey" should be prefixed with an underscore because the declaration is marked as @internal
//
// @internal (undocumented)
export function validateKey(key: any): void;

// @beta
export type VerticalPosition = "top" | "bottom" | "unset";

// @public
export function whitespaceFilter(value: Node, index: number, array: Node[]): boolean;


// Warnings were encountered during analysis:
//
// dist/dts/design-token/design-token.d.ts:91:5 - (ae-forgotten-export) The symbol "create" needs to be exported by the entry point index.d.ts
// dist/dts/di/di.d.ts:499:5 - (ae-forgotten-export) The symbol "SingletonOptions" needs to be exported by the entry point index.d.ts

// (No @packageDocumentation comment for this package)

```
